# Coveo MissingTerms Component (CoveoMissingTerms)

This result template component renders a list of query terms that were not matched by the associated result item.

Available since

  July 2019 Release (v2.6459)

## Index

### Methods

- addTermForcedToAppear
- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- missingTerms
- usageAnalytics

### Component Options

- caption
- clickable
- numberOfTerms

### Constructors

- constructor

## Methods

### addTermForcedToAppear

- addTermForcedToAppear(term: string): void

- - Defined in ui/MissingTerm/MissingTerms.ts :108

  Injects a term in the advanced part of the query expression (aq) to filter out items that do not match the term.

  #### Parameters

  - ##### term: string

    The term to add to the advanced query expression.

  #### Returns void

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### missingTerms

- get (): string[]

- - Defined in ui/MissingTerm/MissingTerms.ts :87

  Returns all original basic query expression terms that were not matched by the result item the component instance is associated with.

  #### Returns string[]

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### caption

caption: string

- Defined in ui/MissingTerm/MissingTerms.ts :43

The text to display before missing terms.

Default: The localized string for `Missing`.

Markup configuration example(s) :

    data-caption='foo'

### clickable

clickable: boolean

- Defined in ui/MissingTerm/MissingTerms.ts :37

Whether to allow the end-user to click a missing term to filter out items that do not match this term.

Default: `true`

Default

  `true`

Markup configuration example(s) :

    data-clickable='true'
    data-clickable='false'

### numberOfTerms

numberOfTerms: number

- Defined in ui/MissingTerm/MissingTerms.ts :52

The maximum number of missing term to be displayed

Default: `5` Minimum value: `1`

Minimum

  `1`

Default

  `5`

Markup configuration example(s) :

    data-number-of-terms='10'

## Constructors

### constructor

- new MissingTerms(element: HTMLElement, options?: IMissingTermsOptions, bindings?: IComponentBindings, result?: IQueryResult): MissingTerms

- Overwrites Component.constructor

  - Defined in ui/MissingTerm/MissingTerms.ts :64

  Creates a new `MissingTerms` component instance.

  #### Parameters

  - ##### element: HTMLElement

    The element on which to instantiate the component.

  - ##### Optional options: IMissingTermsOptions

    The configuration options for the component.

  - ##### Optional bindings: IComponentBindings

    The bindings required by the component to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The query result item to associate the component with.

  #### Returns MissingTerms